/*****************************************************************************/
/*       (C) 1993,1994 R. NADE - M. GRANDCHAMP - All Rights Reserved         */
/*****************************************************************************/
/*    This source-code is NOT public domain nor Freeware, this is part of    */
/*              'The C Programming Package' which is Shareware.              */
/*   If you use this code, please register and get a free Full-VGA version   */
/*****************************************************************************/
                            /*----------------*
                             *   CPPLMEN3.C   *
                             * Menu manager3  *
                             *----------------*/

 /* Included Files */
 # include <stdio.h>
 # include <io.h>
 # include <dos.h>
 # include <fcntl.h>
 # include <bios.h>
 # include <stdlib.h>
 # include <conio.h>

 /* Global Variables */
 extern int bm,i,j,k,l,m,n,t,x,x1,x2,xm,y,y1,y2,ym,z,menu0,menu3,return1;
 extern int colour1,colour2,colour3,colour4,colour5,returning;
 extern unsigned char c0,c1,trashcan[];

 /*----------------------*
  * CHOICE DISPLAY HELP3 *
  *----------------------*/
  void choice_display_help3()
    {
      /* We display the help that concerns the line on */
      /* which is the menu cursor (in red).            */
      if(menu3==1){
	/*  */
        display_help("MENU3   ",25,2,1);     restore_help_screen();
      }
      if(menu3==2){
	/*  */
        display_help("MENU3   ",26,3,1);     restore_help_screen();
      }
      if(menu3==3){
	/*  */
        display_help("MENU3   ",27,4,1);     restore_help_screen();
      }
      if(menu3==4){
	/*  */
        display_help("MENU3   ",28,5,1);     restore_help_screen();
      }
      if(menu3==5){
	/*  */
        display_help("MENU3   ",29,6,1);     restore_help_screen();
      }
      if(menu3==6){
	/*  */
        display_help("MENU3   ",30,7,1);     restore_help_screen();
      }
      if(menu3==7){
        /* available */
        display_help("MENU3   ",31,8,1);     restore_help_screen();
      }
      if(menu3==8){
	/*  */
        display_help("MENU3   ",32,9,1);     restore_help_screen();
      }
      if(menu3==9){
	/*  */
        display_help("MENU3   ",33,10,1);    restore_help_screen();
      }
      if(menu3==10){
	/*  */
        display_help("MENU3   ",34,11,1);    restore_help_screen();
      }
    }
 /*----------------*
  * GET THE MOUSE3 *
  *----------------*/
  int get_the_mouse3()
    {
      /* If we choose with the mouse */
      /* Only available for menu 1   */
      if(ym==1){
        /* We clicked on the first line, certainly */
        /* To change of menu.                      */
        x=get_the_mouse0();
	menu0=x;                       return(-2);
      }
      if((xm>16)&&(xm<33)){
	if(ym==3){
	  /*  */
	  menu3=1;	               return(1);
	}
	if(ym==4){
	  /*  */
	  menu3=2;                     return(1);
	}
	if(ym==5){
	  /*  */
	  menu3=3;                     return(1);
	}
	if(ym==6){
	  /*  */
	  menu3=4;                     return(1);
	}
	if(ym==7){
	  /*  */
	  menu3=5;                     return(1);
	}
	if(ym==8){
	  /*  */
	  menu3=6;                     return(1);
	}
	if(ym==9){
	  /*  */
	  menu3=7;                     return(1);
	}
	if(ym==10){
	  /*  */
	  menu3=8;                     return(1);
	}
	if(ym==11){
	  /*  */
	  menu3=9;                     return(1);
	}
	if(ym==12){
	  /*  */
	  menu3=10;                    return(1);
	}
      }
      /* If we clicked outside the menu zone            */
      /* we want to erase the menu and return to menu 0 */

      menu0=0;                         return(-2);
    }
 /*--------------*
  * MENU CHOICE3 *
  *--------------*/
  int menu_choice3()
    {
      returning=wait_for_a_key();
      /* Else we pressed a keyboard key                            */
      /* Cf CPPLTC2.C for the keyboard test and the returned codes */
      if(returning==-1){
        /* <Esc> we want to go back to menu0 */
	menu0=0;                       return(-2);
      }
      if(returning==40){
        /* <Enter> execute the command */
	return(1);
      }
      if(returning==100){
        /* We pressed a mouse button */
        m=get_the_mouse3();  return(m);
      }
      /* The key letters depends on the menu  */

      /* So the below returns need to be modified */
      if(returning==24){
	/* <O> <o>  */
	menu3=1;                       return(1);
      }
      if(returning==23){
	/* <N> <n>  */
	menu3=2;                       return(1);
      }
      if(returning==28){
	/* <S> <s>  */
	menu3=3;                       return(1);
      }
      if(returning==13){
	/* <D> <d>  */
	menu3=5;                       return(1);
      }
      if(returning==27){
	/* <R> <r>  */
	menu3=6;                       return(1);
      }
      if(returning==18){
	/* <I> <i>  */
	menu3=7;                       return(1);
      }
      if(returning==15){
	/* <F> <f>  */
	menu3=8;                       return(1);
      }
      if(returning==26){
	/* <Q> <q>  */
	menu3=10;	               return(1);
      }
      /* For the 2-bytes coded keys, this is the second byte */
      if(returning==59){
         /* Function key <F1> = help */
	 return(59);
      }
      if(returning>100){
        /* We pressed Alt + another key to get a menu */
        c1=returning-100;                 k=get_special_menu00();
	if(k>0)                        return(-2);
      }
      if((returning==77)||(returning==75)){
        /* Left or Right arrow to change of menu */
        c1=returning;                             k=get_special_menu00();
	if(k>0)                        return(-2);
      }
      if(returning==72){
        /* Up arrow */
	if(menu3>1)                    menu3--;
	else                           menu3=10;
	return(0);
      }
      if(returning==80){
        /* Down arrow */
	if(menu3<10)                   menu3++;
	else                           menu3=1;
	return(0);
      }
      /* Else we return 0 = no choice */
      return(0);
    }
 /*--------------------*
  * DISPLAY LINE menu3 *
  *--------------------*/
  void display_menu_line3()
    {
      /* First we display the chosen menu0 */
      textattr(colour5);
      gotoxy(17,1);                    cputs("  Menu3  ");
      /* Same thing for the selected line */
      if(menu3==1){
	gotoxy(17,3);                  cputs("                ");
      }
      if(menu3==2){
	gotoxy(17,4);                  cputs("                ");
      }
      if(menu3==3){
	gotoxy(17,5);                  cputs("                ");
      }
      if(menu3==4){
	gotoxy(17,6);                  cputs("                ");
      }
      if(menu3==5){
	gotoxy(17,7);                  cputs("                ");
      }
      if(menu3==6){
	gotoxy(17,8);                  cputs("                ");
      }
      if(menu3==7){
	gotoxy(17,9);                  cputs("                ");
      }
      if(menu3==8){
	gotoxy(17,10);                 cputs("                ");
      }
      if(menu3==9){
	gotoxy(17,11);                 cputs("                ");
      }
      if(menu3==10){
	gotoxy(17,12);                 cputs("                ");
      }
    }
 /*----------------------*
  * DISPLAY KEY LETTER 3 *
  *----------------------*/
  void display_key_letter3()
    {
      textattr(116);
      gotoxy(18,3);                   cputs(" ");
      gotoxy(18,4);                   cputs(" ");
      gotoxy(18,5);                   cputs(" ");
      gotoxy(18,6);                   cputs(" ");
      gotoxy(18,7);                   cputs(" ");
      gotoxy(18,8);                   cputs(" ");
      gotoxy(18,9);                   cputs(" ");
      gotoxy(18,10);                  cputs(" ");
      gotoxy(18,11);                  cputs(" ");
      gotoxy(18,12);                  cputs(" ");
    }
 /*---------------*
  * DISPLAY menu3 *
  *---------------*/
  void display_menu3()
    {
      /* To avoid the trace of the previous mouse position */
      /* we hide it during the display,                    */
      /* and show it when the line has been displayed.     */
      hide_the_mouse();               textattr(colour2);
      gotoxy(15,2);                    cputs(" Ŀ ");
      gotoxy(15,3);                    cputs("                  ");
      gotoxy(15,4);                    cputs("                  ");
      gotoxy(15,5);                    cputs("                  ");
      gotoxy(15,6);                    cputs("                  ");
      gotoxy(15,7);                    cputs("                  ");
      gotoxy(15,8);                    cputs("                  ");
      gotoxy(15,9);                    cputs("                  ");
      gotoxy(15,10);                   cputs("                  ");
      gotoxy(15,11);                   cputs("                  ");
      gotoxy(15,12);                   cputs("                  ");
      gotoxy(15,13);                   cputs("  ");
      display_key_letter3();           display_menu_line3();
      show_the_mouse();
    }
 /*----------------*
  * MENU MANAGER 3 *
  *----------------*/
  int menu_manager3()
    {
      restore_screen();                return1=0;
      while(1){
        display_menu3();               return1=menu_choice3();
        if(return1==-2)                return(-2);
        if(return1==-1)                return(-1);
        if(return1==22)                choice_display_help3();
        display_menu3();
        if(return1==1){
          /* We execute the selected function */
	  if(menu3==10){
            /* We want to quit the sub-program */
	    return(-1);
	  }
	  if(menu3==1){
	    /*  */

	  }
	  if(menu3==2){
	    /*  */

	  }
	  if(menu3==3){
	    /*  */

	  }
	  if(menu3==4){
	    /*  */

	  }
	  if(menu3==5){
	    /*  */

	  }
	  if(menu3==6){
	    /*  */

	  }
	  if(menu3==7){
	    /*  */

	  }
	  if(menu3==8){
	    /*  */

	  }
	  if(menu3==9){
	    /*  */

	  }
	}
      }
    }
/* End of the Module *//*----------------*/
